(function ($, Drupal, drupalSettings, once) {

  'use strict';

  /**
   *
   * @type {{attach: Drupal.Homepage_hero.attach}}
   */
  Drupal.behaviors.Homepage_hero = {
    attach: function (context, settings) {
      // HeroDom reference.
      var hhDomEle = '.paragraph--type--homepage-hero .hero-row .homeHeroCard.';

      // Create array for section positions.
      var hhSection = {0: "hfl", 1: "hfr", 2: "hbl", 3: "hbr"};
      var hhSectionCount = Object.keys(hhSection).length;

      // Get slides array from Drupal settings
      var hhSlides = drupalSettings.hero2;
      // console.log(hhSlides);

      // Loop through variables.
      var sectionIndex = 0;
      var slideno = 2;

      // If slides exists, don't change this, as hhSlides will have 0 value is
      // not slides are there.
      if (hhSlides != 0) {

        // Loop through all images & add them to different hhsection.
        $.each(hhSlides, function (slideIndex, value) {
          // As we have max 4 section, so if more than 4 images we have add
          // them to appropriate section.
          sectionIndex = parseInt(sectionIndex % 4);

          var hhDom = $(hhDomEle + hhSection[sectionIndex]);
          var sectionNumCombo = hhSection[sectionIndex] + '-' + slideno;

          hhDom.parent().append('<div class="col-lg-6 ' + hhSection[sectionIndex] + ' ' + sectionNumCombo + ' homeHeroCard" data-slideno="' + slideno + '" data-fl="' + slideIndex + '" style="background-image:url(' + value + ');"></div>');

          // Increment variables for next slide.
          if (slideIndex % hhSectionCount == 0) {
            slideno++;
          }
          sectionIndex++;
        });
      }

      // Setup automatic rotation code for images.
      var sectionIndexT = 0;
      setInterval(function () {

        var hhDomT = $(hhDomEle + hhSection[sectionIndexT]);

        // Get active section element
        var hhDomAct = $(hhDomEle + hhSection[sectionIndexT] + '.active');

        // Get current slide number from active element.
        var slideno = hhDomAct.attr('data-slideno');

        // console.log(sectionIndexT + '--' + slideno);

        // If next slide doesn't exist set slide back to 0.
        if (!$(hhDomEle + hhSection[sectionIndexT] + '-' + (parseInt(slideno) + 1)).length) {
          slideno = 0;
          // console.log('side udpate' + slideno);
        }
        // Remove active class from current slide and add to next slide.
        hhDomAct.removeClass('active');
        $(hhDomEle + hhSection[sectionIndexT] + '-' + (parseInt(slideno) + 1)).addClass('active');

        sectionIndexT = (sectionIndexT >= (hhSectionCount - 1)) ? (sectionIndexT % (hhSectionCount - 1)) : ++sectionIndexT;
      }, 3000);

    }
  }
}(jQuery, Drupal, drupalSettings, once));